/*! +v
 * MIT
 */
import _every from 'lodash/every'

class $switch {
    constructor (_switch) {
        this._switch = _switch
        return this
    }
    reverse () {
        this._reverse = true
        return this
    }
    case (_f) {
        // result
        let result
        // reverse or not
        if (this._reverse) _f = _f.reverse()
        // loop every
        if (_f instanceof Array) {
            return !_every(_f, f => {
                result = f
                return f !== this._switch
            }) && result
        } else if (_f instanceof Object) {
            return !_every(_f, (f, v) => {
                result = f()
                return v !== this._switch && (!isNaN(v) && Number(v) !== this._switch)
            }) && result
        } else {
            return false
        }
    }
}

export default {
    install (Vue, lang) {
        Object.defineProperty(Vue.prototype, '$switch', {
            value: function (_switch) {
                return new $switch(_switch)
            }
        })
    }
}
